function [xdata, ydata] = buildEllipse(a, b, c, d, e, xBounds , yBounds, step)

y = yBounds(1):step:yBounds(2);
x = xBounds(1):step:xBounds(2);

% Determine x from y
c1 = a;
c2 = b*y+d;
c3 = c*y.^2+e*y;
[ydata1,xdata1] = solveQuadraticFunc(y,c1,c2,c3);

% Determine y from x
c1 = c;
c2 = b*x+e;
c3 = a*x.^2+d*x;
[xdata2,ydata2] = solveQuadraticFunc(x,c1,c2,c3);

xdata = [xdata1,xdata2];
ydata = [ydata1,ydata2];

i = find((xdata<=xBounds(2)) .* (xdata>=xBounds(1)) .* (ydata<=yBounds(2)) .* (ydata>=yBounds(1)));
xdata = xdata(i);
ydata = ydata(i);

end

%% Helper Function
function [X,Y] = solveQuadraticFunc (x, c1, c2, c3)

    radicand = c2.^2 - 4*c1*c3;
    xInd = find(radicand>=0);
    
    y1 = (-c2(xInd)+sqrt(radicand(xInd)))/(2*c1);
    y2 = (-c2(xInd)-sqrt(radicand(xInd)))/(2*c1);
    
    X = [x(xInd),x(xInd)];    
    Y = [y1,y2]; 
end