close all;
clear all;

%% Parameters
useSubImage = false;
visualization = false;

nrOfParabolaPoints = 100;
nrOfMaculaEstimates = 16;
iteration = 1;

for scale = [1],
    for useGoldStandard = [0,1],  
        for vesselPointSetAlg = 1:7,
            for curvFitAlg = 1:3,  
                 
                [maculaCenters, maculaError, angleError, meanEyeError] = maculaDetection(scale,useGoldStandard,vesselPointSetAlg,curvFitAlg,visualization,useSubImage)
                
                xlsrows=[2*iteration,2*iteration+1];
                
                % Analysis of 16 Macula Localization Algorithms by measuring
                % deviation from goldstandard macula posistion in pixels
                xlswrite([resultDir,'maculaAlgEval.xls'], {['mean_',identifier];['std_',identifier]}, 1, ['A',num2str(xlsrows(1)),':A',num2str(xlsrows(2))]);
                xlswrite([resultDir,'maculaAlgEval.xls'], maculaError(1,:), 1, ['B',num2str(xlsrows(1)),':Q',num2str(xlsrows(1))]);
                xlswrite([resultDir,'maculaAlgEval.xls'], maculaError(2,:), 1, ['B',num2str(xlsrows(2)),':Q',num2str(xlsrows(2))]);
                
                % Deviation from gold standard angle (angle between x-axis 
                % and line through macula gold standard and optiv nerve center) 
                xlswrite([resultDir,'maculaAlgEval.xls'], {identifier}, 2, ['A',num2str(iteration)]);
                xlswrite([resultDir,'maculaAlgEval.xls'], angleError(:,1), 2, ['B',num2str(iteration)]);
                xlswrite([resultDir,'maculaAlgEval.xls'], angleError(:,2), 2, ['C',num2str(iteration)]);             
                
                % Right/Left Eye Matching Ability: 1 if all images were 
                % correctly matched to right / left eye
                xlswrite([resultDir,'maculaAlgEval.xls'], {identifier}, 3, ['A',num2str(iteration)]);
                xlswrite([resultDir,'maculaAlgEval.xls'], meanEyeError, 3, ['B',num2str(iteration)]);
                
                % Coordinates of estimated macula position in scaled image
                xlswrite([resultDir,'maculaAlgEval.xls'], {['X_',identifier];['Y_',identifier]}, 4, ['A',num2str(xlsrows(1)),':A',num2str(xlsrows(2))]);
                xlswrite([resultDir,'maculaAlgEval.xls'], maculaCenters', 4, ['B',num2str(xlsrows(1)),':Q',num2str(xlsrows(2))]);
                
                iteration = iteration+1;
                

            end
        end
    end
end