close all;
clear all;

image = double(imread('testvessel.png'));
image = imresize(image,0.2);
image = image(150:299,115:254);
[m,n] = size(image);

c = [10,30,60,50,110,130,120]';
r = [144,20,70,30,90,120,10]';

figure, imshow(image,[]), hold on, plot(c,r,'*r');

[vr,vc] = voronoi(r,c);
vr = round(vr);
vc = round(vc);

figure, imshow(image,[]), hold on, plot(c,r,'r*',vc,vr,'b-');

areas = zeros(m,n);
for i=1:size(vr,2),
    lineRows = round(linspace(vr(1,i),vr(2,i)));
    lineCols = round(linspace(vc(1,i),vc(2,i),length(lineRows)));
    j = find((lineRows>0).*(lineRows<=m).*(lineCols>0).*(lineCols<=n));
    areas(sub2ind(size(image),lineRows(j),lineCols(j))) = 1;
end
areas = bwmorph(imdilate(areas,ones(3,3)),'skel',Inf);
figure, imshow(areas,[])
%filled = imfill(areas,[r(1),c(1)],4);